/* capricor.h */

/* definitions des registres d'emulation */

//GLOBAL unsigned char regCPU[64];    // CPU register bank
/* byte order: low, high */

union regcapr
{
  unsigned char byt[64];
  struct sr {
    unsigned short ind;  // R0-1
    unsigned short idx;  // R2-3
    unsigned short pc;   // R4-5
    unsigned short sp;   // R6-R7
    unsigned short r[28];
  } reg;
};

GLOBAL union regcapr  regCPU;

//GLOBAL unsigned int regPC, regSP;   // calculated values from CPU registers
GLOBAL unsigned char regARP, regDRP, regE, regFlags, regROMslt;
GLOBAL int lenDR;

GLOBAL int timerstat, compstat;  // timer and comparator status
GLOBAL long timer;   // timer value
GLOBAL int  timer_l;
GLOBAL long tcomp;   // comparator value
GLOBAL int  tcomp_l;

GLOBAL int fintr;   // GIE global interrupt enabled
GLOBAL int fwrom;   // ROM writable

//GLOBAL int powerstat;  // power status

GLOBAL unsigned char regLCD[34];  // physical LCD: 32 char + 2 announc. bytes

/* flags: (more and less in the order of SAD/PAD opcodes) */
#define m_MSB (1<<7)
#define m_LDZ (1<<6)
#define m_OVF (1<<5)
#define m_DCM (1<<4)
#define m_CY  (1<<3)
#define m_Z   (1<<2)
#define m_RDZ (1<<1)
#define m_LSB (1<<0)


/* table des segments memoire */
GLOBAL unsigned short tab_seg[8];   // 8 segments of 8 kB


/* ROM system :
  ROM 0-2 system ROM at 0000-5fff
  ROM 3 ALTROM by default at 6000
  ROM 4 BASROM at E000
  ROM 5 MELROM at 6000 (bank switched)
*/

/* table des banks */
//GLOBAL unsigned short tab_bank[24];  // 4 ports (0-3), 6 8k-ROM per port */
/* note: there is provision for 24 ROM, but the HP75 ROMTAB has room for only 21
 and HP75 code doesn't check for table full. Limit the number of plug-in ROM to 16
 to take into account the 3 internal system ROM plus the end of table mark */


/*  */

/* I/O address FF00 to FFFF, no address incrementation in multibyte tranfer
FF55 test pad low
FFAA test pad high
FF00 W Global interrupt enable
FF01 W Global interrupt disable
FF02 W Keyboard status

FF08 R/W card reader status & data
FF10-17 R/W HPIL

FF30-4f W ROM bank switching
from Service manual, CJPPC V3N4p19
(enable/disable)

FF30-31 port 1, ROM C   ROM3A
FF32-33 port 2, ROM C   ROM1A
FF34-35 port 3, ROM C   ROM2A
FF36-37 port 0?,ROM C
FF38-39 port 1, ROM D   ROM3B
FF3a-3b port 2, ROM D   ROM1B
FF3c-3d port 3, ROM D   ROM2B
FF3e-3f port 0?,ROM D

FF40-41 port 1, ROM A   ROM3C
FF42-43 port 2, ROM A   ROM1C
FF44-45 port 3, ROM A   ROM2C
FF46-47 port 0?,ROM A   system SYSROM    ALTROM
FF48-49 port 1, ROM B   ROM3D
FF4a-4b port 2, ROM B   ROM1D
FF4c-4d port 3, ROM B   ROM2D
FF4e-4f port 0?,ROM B   system MELROM

FF50-5F enables new ROMs including the "MEMIC".

Writing to the odd FF4x addresses disables all roms (see UNROM 47E2h).
For emulation, assume all ROM are disabled by a write to any odd FF4x
Enabling one ROM disables all the other ROMs.

in HP75 code ROMSET (47EDh), all addresses from FF30 to FF5E are scanned

FF80 R/W comparator status/5 data bytes
FF81 R/W RTC status/5 data bytes
FF82 R/W power detect status/DAC data
FFFC R LCD display ctrl status
FFFC W LCD display ctrl 2 data bytes

altrom1: 00 EA A8 99 : 09/09/81

*/






/* il devices */
GLOBAL int nbdev;  /* number of devices */
GLOBAL int tabdev[32];


