/* ems.c
  EMS support for Emu71 */


#include <stdio.h>
#include <dos.h>


static int EmsHandler=0;


int static EmsPresent(void)
{
 /* -Returns true if the Expanded Memory Manager is installed. */
 FILE *F;

 F=fopen("EMMXXXX0","rb");
 if (F!=NULL)
   {
   fclose(F);
   return(1);
   }
 return(0);
}


int static EmsStatus(void)
{
  _AH = 0x40;
  geninterrupt(0x67);
  return(_AH);
}

int static EmsAlloc(int pages)
{
  int err;

  _BX=pages;
  _AH = 0x43;
  geninterrupt(0x67);
  err=_AH;
  EmsHandler=_DX;
  return(err);
}

int static EmsMap(int logical, int physical)
{
  _DX=EmsHandler;
  _BX=logical;
  _AL=physical;
  _AH = 0x44;
  geninterrupt(0x67);
  return(_AH);
}

int static EmsSegment(void)
{
  _AH = 0x41;
  geninterrupt(0x67);
  if (_AH==0)
    return(_BX);
  else
    return(0);
}

int static EmsFree(void)
{
  _DX=EmsHandler;
  _AH = 0x45;
  geninterrupt(0x67);
  return(_AH);
}




/* ************************************* */

int GetEmsSegment(void)
{
  int err, seg;

  seg=0;
  if (EmsPresent()) {
    if (EmsStatus()==0) {
      err=EmsAlloc(4);
      if (err==0) {
        EmsMap(0,0);
        EmsMap(1,1);
        EmsMap(2,2);
        EmsMap(3,3);
        seg=EmsSegment();
      }
    }
  }
  return(seg);
}


int EndEms(void)
{
  if (EmsHandler!=0)
    EmsFree();
  return(0);
}

